summary |
shortlog |
log |
commit | commitdiff |
tree
raw |
patch |
inline | side by side (from parent 1:
ee519cf)
Instead of specifying a finite number of process command arguments or
attempting to use an array to specify dynamic numbers of process
command arguments, instead, accept only a single command string
argument. If desired, multiple process command strings can be
concatenated before the combined string is provided as a single
argument to appendFileTar().
-
-# Desc: Template function to write data supplied as argument
+# Desc: Append [processed] file to tar
yell() { echo "$0: $*" >&2; } # Yell, Die, Try Three-Fingered Claw technique; # Ref/Attrib: https://stackoverflow.com/a/25515370
die() { yell "$*"; exit 111; }
try() { "$@" || die "cannot $*"; }
appendFileTar(){
yell() { echo "$0: $*" >&2; } # Yell, Die, Try Three-Fingered Claw technique; # Ref/Attrib: https://stackoverflow.com/a/25515370
die() { yell "$*"; exit 111; }
try() { "$@" || die "cannot $*"; }
appendFileTar(){
- # Desc: Processes first file and then appends to tar
- # Usage: appendFileTar [file path] [name of file to be inserted] [tar path] [temp dir] ([cmd1] [cmd2] [cmd3] [cmd4]...)
- # Version: 1.0.3
+ # Desc: Appends [processed] file to tar
+ # Usage: appendFileTar [file path] [name of file to be inserted] [tar path] [temp dir] ([process cmd])
+ # Version: 2.0.0
# Input: arg1: path of file to be (processed and) written
# arg2: name to use for file inserted into tar
# arg3: tar archive path (must exist first)
# arg4: temporary working dir
# Input: arg1: path of file to be (processed and) written
# arg2: name to use for file inserted into tar
# arg3: tar archive path (must exist first)
# arg4: temporary working dir
- # arg5+: command strings (ex: "gpsbabel -i nmea -f - -o kml -F - ")
+ # arg5: (optional) command string to process file (ex: "gpsbabel -i nmea -f - -o kml -F - ")
# Output: file written to disk
# Example: decrypt multiple large files in parallel
# appendFileTar /tmp/largefile1.gpg "largefile1" $HOME/archive.tar /tmp "gpg --decrypt" &
# appendFileTar /tmp/largefile2.gpg "largefile2" $HOME/archive.tar /tmp "gpg --decrypt" &
# appendFileTar /tmp/largefile3.gpg "largefile3" $HOME/archive.tar /tmp "gpg --decrypt" &
# Output: file written to disk
# Example: decrypt multiple large files in parallel
# appendFileTar /tmp/largefile1.gpg "largefile1" $HOME/archive.tar /tmp "gpg --decrypt" &
# appendFileTar /tmp/largefile2.gpg "largefile2" $HOME/archive.tar /tmp "gpg --decrypt" &
# appendFileTar /tmp/largefile3.gpg "largefile3" $HOME/archive.tar /tmp "gpg --decrypt" &
- # Depends: bash 5, tar 1, yell()
-
+ # Depends: bash 5.0.3, tar 1.30, cat 8.30, yell()
local fn fileName tarPath tmpDir
# Save function name
fn="${FUNCNAME[0]}";
local fn fileName tarPath tmpDir
# Save function name
fn="${FUNCNAME[0]}";
- #yell "DEBUG:STATUS:$fn:Finished appendFileTar()."
+ #yell "DEBUG:STATUS:$fn:Started appendFileTar()."
# Set file name
if ! [ -z "$2" ]; then fileName="$2"; else yell "ERROR:$fn:Not enough arguments."; exit 1; fi
# Set file name
if ! [ -z "$2" ]; then fileName="$2"; else yell "ERROR:$fn:Not enough arguments."; exit 1; fi
# Check temp dir arg
if ! [ -z "$4" ]; then tmpDir="$4"; else yell "ERROR:$fn:No temporary working dir set."; exit 1; fi
# Set command strings
# Check temp dir arg
if ! [ -z "$4" ]; then tmpDir="$4"; else yell "ERROR:$fn:No temporary working dir set."; exit 1; fi
# Set command strings
- if ! [ -z "$5" ]; then cmd1="$5"; else cmd1="cat "; fi # command string 1
- if ! [ -z "$6" ]; then cmd2="$6"; else cmd2="cat "; fi # command string 2
- if ! [ -z "$7" ]; then cmd3="$7"; else cmd3="cat "; fi # command string 3
- if ! [ -z "$8" ]; then cmd4="$8"; else cmd4="cat "; fi # command string 4
+ if ! [ -z "$5" ]; then cmd1="$5"; else cmd1="cat "; fi # command string
- cmd0="cat \"\$1\""
-
- # # Debug
- # yell "DEBUG:STATUS:$fn:cmd0:$cmd0"
- # yell "DEBUG:STATUS:$fn:cmd1:$cmd1"
- # yell "DEBUG:STATUS:$fn:cmd2:$cmd2"
- # yell "DEBUG:STATUS:$fn:cmd3:$cmd3"
- # yell "DEBUG:STATUS:$fn:cmd4:$cmd4"
- # yell "DEBUG:STATUS:$fn:fileName:$fileName"
- # yell "DEBUG:STATUS:$fn:tarPath:$tarPath"
- # yell "DEBUG:STATUS:$fn:tmpDir:$tmpDir"
# Write to temporary working dir
# Write to temporary working dir
- eval "$cmd0 | $cmd1 | $cmd2 | $cmd3 | $cmd4" > "$tmpDir"/"$fileName";
+ eval "$cmd0 | $cmd1" > "$tmpDir"/"$fileName";
# Append to tar
try tar --append --directory="$tmpDir" --file="$tarPath" "$fileName";
# Append to tar
try tar --append --directory="$tmpDir" --file="$tarPath" "$fileName";
try tar --create --file="$myTar" --files-from=/dev/null ;
myFile="/tmp/$(date +%s)..original";
echo "how are you doing?" > "$myFile";
try tar --create --file="$myTar" --files-from=/dev/null ;
myFile="/tmp/$(date +%s)..original";
echo "how are you doing?" > "$myFile";
-appendFileTar "$myFile" "$(date +%s)..LOUD_insidetar" "$myTar" "$myTmpDir" "tee /tmp/$(date +%s)..outsidetar " "tr '[:lower:]' '[:upper:]'" && \
+appendFileTar "$myFile" "$(date +%s)..LOUD_insidetar" "$myTar" "$myTmpDir" "tee /tmp/$(date +%s)..outsidetar | tr '[:lower:]' '[:upper:]'" && \
echo "Inserted a processed version of $myFile into $myTar using temp dir $myTmpDir ";
#==END sample code==
echo "Inserted a processed version of $myFile into $myTar using temp dir $myTmpDir ";
#==END sample code==